(********************************************************************)
(*	file: 		ADSPHangUp.p										*)
(*	version:	.5alpha												*)
(* 																	*)
(* Disconnect an established connection and deallocate the data 	*)
(* associated with the connection.									*)
(*																	*)
(* In:	params[1] ::= Entity Name of the NBP entity to hangup on	*)
(* 																	*)
(* Out:	the Result ::= error message, empty if none.				*)
(*																	*)
(* ----------------------------------------------------------------	*)
(* By:		Donald Koscheka											*)
(* Date:	4-Feb-88												*)
(* 				Copyright 1988, Apple Computer, Inc.				*)
(*			All Rights Reserved										*)
(*																	*)
(* ----------------------------------------------------------------	*)
(*						Modification History						*)
(* ----------------------------------------------------------------	*)
(*  Date	| By	|	 				Description					*)
(* ----------------------------------------------------------------	*)
(* 4-Feb-88	| DK	| file created									*)
(* 17-Mar-88| DK	| ALPHA RELEASE									*)
(* ----------------------------------------------------------------	*)
(********************************************************************)

(********************************************************************
							Build Sequence

pascal -o "{hpo}"ADSPHangUp.p.o "{adsp}"ADSPHangUp.p
link -m ENTRYPOINT  -rt XCMD=1304 -sn Main=ADSPHangUp
	"{hpo}"ADSPHangUp.p.o
	"{libraries}"Interface.o 
	"{plibraries}"paslib.o
	-o "{hp}"HyperADSPTest
		 
********************************************************************)


{$R-}
{$S ADSPHangUp}
UNIT DummyUnit;

(*******************************************************************)
INTERFACE 
(*******************************************************************)


Uses MemTypes, QuickDraw, OSIntf, ToolIntf, PackIntf, HyperXCmd, AppleTalk, ADSP, adspxcmd;


Procedure EntryPoint( paramPtr : XCmdPtr );


(*******************************************************************)
IMPLEMENTATION
(*******************************************************************)


PROCEDURE ADSPHangUp( paramPtr: XCmdPtr ); FORWARD;

Procedure EntryPoint( paramPtr : XCmdPtr );
	Begin
		ADSPHangUp( paramPtr );
	End;
	
	
Procedure ADSPHangUp( paramPtr : XCmdPtr );
VAR
	adsp		: ADSPPtr;
	error		: OSErr;
	pb			: DSPParamBlock;
	eAddr		: AddrBlock;
	cb			: CBPtr;
{$I XCmdGlue.inc }
{$I XCMDADSP.inc }	
	

(*****************************  ADSPHangUp	*******************************)
BEGIN
	error := noErr;
	IF ( paramPtr^.paramCount > 0 ) AND ( paramPtr^.params[1] <> NIL ) THEN		
		BEGIN
			adsp := ADSPPtr(RetrieveHandle( GLOBALDSPDATA ));
			IF adsp <> NIL THEN
				BEGIN
					adsp^.checkPoint := RECEIVING;
					{*** (1) Get the entity's address 						***}
					HLock( Handle(paramPtr^.params[1]) );
					eAddr := NBPGetAddress( paramPtr^.params[1]^ );
					cb := adsp^.ends;
					
					IF LongInt(eAddr) <> 0 THEN {*** match the entity to the list ***}					
						WHILE cb <> NIL DO
							IF LongInt(cb^.adr ) = LongInt( eAddr ) THEN
								BEGIN
									error := DSPHangUp( cb );
									cb := NIL;
								END
							ELSE
								cb := cb^.next;
						
					HUnlock( Handle(paramPtr^.params[1]) );
					adsp^.checkPoint := CLOSE_OK;
				END
		END;
	paramPtr^.returnValue := ErrorReturn( error );
END;

end.
