(********************************************************************)
(*	file:		GetZoneInfo.P										*)
(*	version:	.5alpha												*)
(*																	*)
(* Get Zone	Information for the current zone of for all zones that	*)
(* are visible at this point in time.								*)
(*																	*)
(* In: paramPtr^.params[1] = TRUE if get all zones, FALSE if get	*)
(*				current zone only.									*)
(*																	*)
(* Returns the zone information table as a handle					*)
(* ----------------------------------------------------------------	*)
(* By:		Donald Koscheka											*)
(* Date:	26-Apr-88												*)
(*  Copyright 1987, Apple Computer, Inc.							*)
(* All Rights Reserved												*)
(*																	*)
(* ----------------------------------------------------------------	*)
(*						Modification History						*)
(* ----------------------------------------------------------------	*)
(*  Date	   	| By	|	 				Description				*)
(* ----------------------------------------------------------------	*)
(*  26-Apr-88	| DK	| File Created								*)
(* ----------------------------------------------------------------	*)
(********************************************************************)


(********************************************************************)
(*  Assumes the XCMD has included this file and has named its 		*)
(*	argument "paramPtr".											*)
(********************************************************************)
(********************************************************************
							Build Sequence

pascal -o "{hpo}"GetZoneInfo.p.o "{adsp}"GetZoneInfo.p
link -m ENTRYPOINT  -rt XFCN=1308 -sn Main=GetZoneInfo
	"{hpo}"GetZoneInfo.p.o
	"{libraries}"Interface.o 
	"{plibraries}"paslib.o
	-o "{hp}"HyperADSPTest
		 
********************************************************************)


{$R-}
{$S GetZoneInfo}
UNIT Koscheka;

(*******************************************************************)
INTERFACE 
(*******************************************************************)


Uses MemTypes, QuickDraw, OSIntf, ToolIntf, PackIntf, 
	HyperXCmd, AppleTalk, ADSP, adspxcmd;


Procedure EntryPoint( paramPtr : XCmdPtr );


(*******************************************************************)
IMPLEMENTATION
(*******************************************************************)


PROCEDURE GetZoneInfo( paramPtr: XCmdPtr ); FORWARD;

Procedure EntryPoint( paramPtr : XCmdPtr );
	Begin
		GetZoneInfo( paramPtr );
	End;
	
	
Procedure GetZoneInfo( paramPtr : XCmdPtr );
VAR
	adsp		: ADSPPtr;		{*** Not Used By this routine ***}
	whichZones	: BOOLEAN;
	temp		: Str255;
	dumbPtr		: Ptr;
	
{$I XCmdGlue.inc }
{$I XCMDADSP.inc }	

(*****************************  GetZoneInfo	*******************************)
BEGIN
	IF paramPtr^.params[1] <> NIL THEN {*** use the stuff provided by user	***}
		BEGIN
			HLock( paramPtr^.params[1] );
			DumbPtr := paramPtr^.params[1]^;			
			ZeroToPas( dumbPtr, temp );
			whichZones := StrToBool( temp );
			HUnlock( paramPtr^.params[1] );
		END
	ELSE								{*** assume user wants all zones	***}
		whichZones := FALSE; 

	paramPtr^.returnValue := LookUpZones( whichZones );
END;

end.









