/*******************************************************************\
*	file: 		NBPClose.c											*
*	version:	1.06												*
* 																	*
* Create the control block and initialize the data for access to the*
* name binding protocol (nbp) stuff.								*
*																	*
* -----------------------------------------------------------------	*
* By:	Donald Koscheka												*
* Date:	14-January, 1988											*
* 	Copyright 1988, Apple Computer, Inc.							*
*	All Rights Reserved												*
*																	*
* -----------------------------------------------------------------	*
*						Modification History						*
* -----------------------------------------------------------------	*
*  Date	   	| By	|	 				Description					*
* -----------------------------------------------------------------	*
* 14-Jan-88	| DK	| file created									*
* -----------------------------------------------------------------	*
\*******************************************************************/

/*******************************************************************\
							Build Sequence
							
C -q2 -g -o "{hpo}"NBPClose.c.o "{nbp}"NBPClose.c
	link  -sn Main=NBPClose -sn STDIO=NBPClose 
		 -sn INTENV=NBPClose -rt XCMD=307 
		 -m NBPCLOSE 
		  "{hpo}"NBPClose.c.o "{hpo}"atalkxcmd.c.o "{hpo}"xcmdutils.c.o 
		 "{CLibraries}"CInterface.o 
		 "{Libraries}"Interface.o 
		 -o "{hp}"HyperAppleTalk

\*******************************************************************/

#include <Types.h>
#include <Memory.h>
#include <Resources.h>
#include <OSUtils.h>
#include <appleTalk.h>
#include <HyperXCmd.h>
#include <atalkXCMD.h>
#include <XCMDUtils.h>


pascal void NBPClose(paramPtr)
	XCmdBlockPtr	paramPtr;
/**********************************
* In:	nil
*
* Out: Error Result is returned to hypercard
**********************************/
{
	NBPBlock 	*nbp;
	short		result = noErr;
	
	nbp = (NBPBlock *)RetrieveHandle(paramPtr, GLOBALNBPDATA );
	if( nbp ){
		result = NBPKill( nbp );
		SaveHandle( paramPtr, GLOBALNBPDATA, nil );
		SaveHandle( paramPtr, GLOBALSKTDATA, nil );
	}
	paramPtr->returnValue = ErrorReturn( result );
}

