/*******************************************************************\
*	file: 		NBPOPen.c											*
*	version:	1.06												*
* 																	*
* Create the control block and initialize the data for access to the*
* name binding protocol (nbp) stuff.								*
*																	*
* -----------------------------------------------------------------	*
* By:	Donald Koscheka												*
* Date:	14-January, 1988											*
* 	Copyright 1988, Apple Computer, Inc.							*
*	All Rights Reserved												*
*																	*
* -----------------------------------------------------------------	*
*						Modification History						*
* -----------------------------------------------------------------	*
*  Date	   	| By	|	 				Description					*
* -----------------------------------------------------------------	*
* 14-Jan-88	| DK	| file created									*
* -----------------------------------------------------------------	*
\*******************************************************************/

/*******************************************************************\
							Build Sequence
							
C -q2 -g -o "{hpo}"NBPOpen.c.o "{nbp}"NBPOpen.c
	link  -sn Main=NBPOpen -sn STDIO=NBPOpen 
		 -sn INTENV=NBPOpen -rt XCMD=308 
		 -m NBPOPEN 
		  "{hpo}"NBPOpen.c.o "{hpo}"atalkxcmd.c.o "{hpo}"xcmdutils.c.o 
		 "{CLibraries}"CRuntime.o 
		 "{CLibraries}"CInterface.o 
		 "{Libraries}"Interface.o 
		 -o "{hp}"HyperAppleTalk

\*******************************************************************/

#include <Types.h>
#include <Memory.h>
#include <Resources.h>
#include <OSUtils.h>
#include <appleTalk.h>
#include <HyperXCmd.h>
#include <atalkXCMD.h>
#include <XCMDUtils.h>


pascal void NBPOpen( paramPtr )
	XCmdBlockPtr	paramPtr;
/**********************************
* In:
*	params[0]	char	*NodeType
*
* Defaults : CLIENT/SERVER
*
* Out: Error Result is returned to hypercard
**********************************/
{
	NBPBlock 	*nbp	= nil;
	short		error	= noErr;

	/*** Don't reopen if ATStuff is already allocated ***/
	nbp = (NBPBlock *)RetrieveHandle( paramPtr, GLOBALNBPDATA );
	if( !nbp ){ 
		nbp = NBPInit();
		SaveHandle( paramPtr, GLOBALNBPDATA, nbp );

		if( !nbp )
			error = DEFAULT_ERROR;
	}	

	paramPtr->returnValue = ErrorReturn( error );
	
}
