(*
	videoChapter() -- Return the chapter number of the frame the player is currently displaying.

	To compile and link this file using Macintosh Programmer's Workshop,

		pascal -w videoChapter.p

		link -m ENTRYPOINT -o HyperCommands -rt XFCN=8006 -sn Main=videoChapter 
			videoChapter.p.o "{MPW}"Libraries:interface.o "{MPW}"PLibraries:PasLib.o

	Copyright  1988 Apple Computer, Inc.

	2/88 - Initial coding by Harry R. Chesley.
*)

{$R-}

{$S videoChapter } 	{ Segment name must be the same as the command name. }

unit DummyUnit;

interface

uses MemTypes, QuickDraw, OSIntf, ToolIntf, HyperXCmd;

procedure EntryPoint(paramPtr: XCmdPtr);
	
implementation

type

Str31 = String[31];

procedure videoChapter(paramPtr: XCmdPtr); forward;

procedure EntryPoint(paramPtr: XCmdPtr);

	begin
		videoChapter(paramPtr);
	end;

procedure videoChapter(paramPtr: XCmdPtr);

	{$I XCmdGlue.inc}

	procedure Fail(errMsg: Str255); { set theResult and quit }
		begin
			paramPtr^.returnValue := PasToZero(errMsg);
			exit(videoChapter);
		end;

	{$I VideoUtil.inc}

	begin
		if paramPtr^.paramCount <> 0 then Fail('parameter count is not 0');

		{ Clear out any pending input. }
		EvalAndDispose('recvUpTo(empty,0,empty)');

		{ Get the current chapter number... }
		paramPtr^.returnValue := PasToZero(videoFunc('chapter',''))
	end;

end.
