(*
	videoFrame() -- Return the frame number of the frame the player is currently displaying.

	To compile and link this file using Macintosh Programmer's Workshop,

		pascal -w videoFrame.p

		link -m ENTRYPOINT -o HyperCommands -rt XFCN=8002 -sn Main=videoFrame 
			videoFrame.p.o "{MPW}"Libraries:interface.o "{MPW}"PLibraries:PasLib.o

	Copyright  1987,88 Apple Computer, Inc.

	9/87 - Initial coding by Harry R. Chesley.
	2/88 - Changed for new interface specification by Harry R. Chesley.
*)

{$R-}

{$S videoFrame } 	{ Segment name must be the same as the command name. }

unit DummyUnit;

interface

uses MemTypes, QuickDraw, OSIntf, ToolIntf, HyperXCmd;

procedure EntryPoint(paramPtr: XCmdPtr);
	
implementation

type

Str31 = String[31];

procedure videoFrame(paramPtr: XCmdPtr); forward;

procedure EntryPoint(paramPtr: XCmdPtr);

	begin
		videoFrame(paramPtr);
	end;

procedure videoFrame(paramPtr: XCmdPtr);

	{$I XCmdGlue.inc}

	procedure Fail(errMsg: Str255); { set theResult and quit }
		begin
			paramPtr^.returnValue := PasToZero(errMsg);
			exit(videoFrame);
		end;

	{$I VideoUtil.inc}

	begin
		if paramPtr^.paramCount <> 0 then Fail('parameter count is not 0');

		{ Clear out any pending input. }
		EvalAndDispose('recvUpTo(empty,0,empty)');

		{ Get the current frame number... }
		paramPtr^.returnValue := PasToZero(videoFunc('frame',''))
	end;

end.
