(*
	videoSpeeds() -- Return a list of the valid frames-per-second speeds for this player.

	To compile and link this file using Macintosh Programmer's Workshop,

		pascal -w videoSpeeds.p

		link -m ENTRYPOINT -o HyperCommands -rt XFCN=8004 -sn Main=videoSpeeds 
			videoSpeeds.p.o "{MPW}"Libraries:interface.o "{MPW}"PLibraries:PasLib.o

	Copyright  1987,88 Apple Computer, Inc.

	9/87 - Initial coding by Harry R. Chesley.
	2/88 - Changed for new interface specification by Harry R. Chesley.
*)

{$R-}

{$S videoSpeeds } 	{ Segment name must be the same as the command name. }

unit DummyUnit;

interface

uses MemTypes, QuickDraw, OSIntf, HyperXCmd;

procedure EntryPoint(paramPtr: XCmdPtr);
	
implementation

type

Str31 = String[31];

procedure videoSpeeds(paramPtr: XCmdPtr); forward;

procedure EntryPoint(paramPtr: XCmdPtr);

	begin
		videoSpeeds(paramPtr);
	end;

procedure videoSpeeds(paramPtr: XCmdPtr);

	{$I XCmdGlue.inc}

	procedure Fail(errMsg: Str255); { set theResult and quit }
		begin
			paramPtr^.returnValue := PasToZero(errMsg);
			exit(videoSpeeds);
		end;

	{$I VideoUtil.inc}

	begin
		if paramPtr^.paramCount <> 0 then Fail('parameter count is not 0');

		{ Get the speeds this player'll handle. }
		paramPtr^.returnValue := PasToZero(videoFunc('speeds',''))
	end;

end.
